/*
** author: Buddha-Pest (buddha@beatdown12.com)
**
**  this script will change the map to lure_map
**   whenever there are not enough players
**   on the server
**
*/

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

/*
** change the following 3 variables to your liking
**
**  userThresholdAtEnd - this many users or less at end of map
**                         and we go to popular map
**  userThresholdAnyTime - if we ever fall to this number or less
**                          we go to popular map immediately
**  lureMap - name of map to switch to
**
*/

/* add 1 to the two following if you have HLTV */
new userThresholdAtEnd = 4;
new userThresholdAnyTime = 0;
new lureMap[MAX_TEXT_LENGTH] = "de_dust";

new STRING_VERSION[MAX_DATA_LENGTH] = "1.01.00";

public SwitchMapAtEnd() {
        /* check number of current players */
        if (playercount() <= userThresholdAtEnd) {
                /* too few players, switch to lure map */
                new Text[MAX_TEXT_LENGTH];
                snprintf (Text, MAX_TEXT_LENGTH, "switching map to %s to lure more players", lureMap);
                say (Text);
                changelevel (lureMap, 4);
        }
}

public SwitchMapAnyTime() {
        /* ckeck number of current players */
        if (playercount() <= userThresholdAnyTime) {
                /* too few players left */
                /* check if we're already on lure map */
                new currentMap[MAX_TEXT_LENGTH];
                currentmap (currentMap, MAX_TEXT_LENGTH);
                if (!streq (currentMap, lureMap)) {
                        /* too few players, switch to lure map */
                        new Text[MAX_TEXT_LENGTH];
                        snprintf (Text, MAX_TEXT_LENGTH, "switching map to %s to lure more players", lureMap);
                        say (Text);
                        changelevel (lureMap, 4);
                }
        }
}

public plugin_init() {
        plugin_registerinfo ("Admin Lure", "switches to a popular map whenever the user count drops below a certain number.",STRING_VERSION);

        new tl = timeleft(0);
        if (tl > 60) {
                /* check and do the switch if necessary */
                set_timer ("SwitchMapAtEnd", tl - 60, 1);
        }

        set_timer ("SwitchMapAnyTime", 60, 99999);

        return PLUGIN_CONTINUE;
}
